### =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, playerlib, cmdlib, gamethread, usermsg, random
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func   = es.import_addon('sam/functions')
core   = es.import_addon('sam/core')
admins = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
box     = {'#all':('Kick','Respawn'),
       	   '#alive':('Slay','Freeze','Noclip','Godmode','Jetpack','Blind','Firework','Health','Rave','Cash','Slap'),
           'others':('Ban','Unban','Mute','Manage Teams') }
sort    = ('Kick','Ban','Unban','Manage Teams','Mute','Slay','Slap','Respawn','Blind',
		   'Freeze','Jetpack','Rave','Firework','Noclip','Godmode','Health','Cash')
toggle  = ('freeze','noclip','godmode','jetpack','blind','rave')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# LOAD FUNCTIONS
	for x in ['ban','mute','manageteams']: es.load('sam/core/pcontrol/%s' % x)

	# SET PLAYERS VARS
	for ply in es.getUseridList():
		for x in toggle: es.set('sam_%s_%s' % (x,ply), 0)

	# CMDS
	cmdlib.registerSayCommand('!kick', kickCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_kick', kickCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!slay', slayCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_slay', slayCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!firework', fireworkCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_firework', fireworkCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!noclip', noclipCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_noclip', noclipCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!jetpack', jetpackCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_jetpack', jetpackCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!blind', blindCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_blind', blindCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!godmode', godmodeCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_godmode', godmodeCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!freeze', freezeCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_freeze', freezeCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!rave', raveCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_rave', raveCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!slap', slapCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_slap', slapCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!respawn', respawnCMD, 'SAM CMD')
	cmdlib.registerSayCommand('!sam_respawn', respawnCMD, 'SAM CMD')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# TAKE EFFECTS FROM PLAYERS BEFORE UNLOAD
	for x in playerlib.getPlayerList('#all'):
		# CANCEL DELAYS
		gamethread.cancelDelayed('sam_firework_%s' % x)
		# REMOVE FUNCTIONS
		for item in toggle: es.set('sam_%s_%s' % (item,x),0)
		unfreeze(x, False)
		unnoclip(x, False)
		ungod(x, False)
		unjetpack(x, False)
		unblind(x, False)
		unrave(x, False)

	# CMDS
	cmdlib.unregisterSayCommand('!kick')
	cmdlib.unregisterSayCommand('!sam_kick')
	cmdlib.unregisterSayCommand('!slay')
	cmdlib.unregisterSayCommand('!sam_slay')
	cmdlib.unregisterSayCommand('!firework')
	cmdlib.unregisterSayCommand('!sam_firework')
	cmdlib.unregisterSayCommand('!noclip')
	cmdlib.unregisterSayCommand('!sam_noclip')
	cmdlib.unregisterSayCommand('!jetpack')
	cmdlib.unregisterSayCommand('!sam_jetpack')
	cmdlib.unregisterSayCommand('!blind')
	cmdlib.unregisterSayCommand('!sam_blind')
	cmdlib.unregisterSayCommand('!godmode')
	cmdlib.unregisterSayCommand('!sam_godmode')
	cmdlib.unregisterSayCommand('!freeze')
	cmdlib.unregisterSayCommand('!sam_freeze')
	cmdlib.unregisterSayCommand('!rave')
	cmdlib.unregisterSayCommand('!sam_rave')
	cmdlib.unregisterSayCommand('!slap')
	cmdlib.unregisterSayCommand('!sam_slap')
	cmdlib.unregisterSayCommand('!respawn')
	cmdlib.unregisterSayCommand('!sam_respawn')

	# UNLOAD FUNCTIONS
	for x in ['ban','mute','manageteams']: es.unload('sam/core/pcontrol/%s' % x)

	# POPUPS
	func.popupDelete('pcontrol')
	func.popupDelete('playersList')
	func.popupDelete('getHealth')
	func.popupDelete('getCash')
	func.popupDelete('getDMG')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	func.popupDelete('pcontrol')
	popup = func.easymenu(popuplib.easymenu('pcontrol', None, listPlayers),'home')
	popup.settitle(func.header(func.langCommon('TITLE_PCONTROL')))
	for x in sort: popup.addoption(x, x)
	if SEND: popup.send(ID)

# ------------------------------------------------------------------------------- #
def listPlayers(ID, OPTION, POPUP, PAGE=False,SEND=True):
	if admins.can(ID,OPTION):
		if not OPTION in box['others']:
			for x in box:
				if OPTION in box[x]: plist = playerlib.getPlayerList(x)
			if len(plist) > 0:
				func.popupDelete('playersList')
				popup = func.easymenu(popuplib.easymenu('playersList', None, filterChoosen),'pcontrol')
				popup.settitle(func.header(func.langPcontrol(OPTION.replace(' ','_').upper())))
				for x in plist: popup.addoption([OPTION,x], x.name)
				if PAGE in plist: popup.sendPage(func.sendPage(plist.index(PAGE)))
				else: popup.send(ID)
				SEND = False
			else: func.hudhint(ID, func.langCommon('NO_ALIVE'), func.errortag)
		else:
			module = es.import_addon('sam/core/pcontrol/%s' % OPTION.replace(' ','').replace('Un','').lower())
			if OPTION == 'Ban': module.banPage(ID)
			elif OPTION == 'Unban': module.unbanPage(ID)
			else: module.page(ID)
			SEND = False
	if SEND: page(ID)

# ------------------------------------------------------------------------------- #
def filterChoosen(ID, TOKENS, POPUP, SEND=True):
	if admins.immunity(playerlib.getPlayer(ID),TOKENS[1],SEND):
		if   TOKENS[0] == 'Kick':     kick(ID, TOKENS[1], None)
		elif TOKENS[0] == 'Slay':     slay(ID, TOKENS[1])
		elif TOKENS[0] == 'Respawn':  respawn(ID, TOKENS[1])
		elif TOKENS[0] == 'Firework': firework(ID, TOKENS[1])
		elif TOKENS[0] == 'Slap':
			getDMG(ID, TOKENS[1])
			SEND = False
		elif TOKENS[0] == 'Health':
			getHealth(ID, TOKENS[1])
			SEND = False
		elif TOKENS[0] == 'Cash':
			getCash(ID, TOKENS[1])
			SEND = False
		elif TOKENS[0] == 'Freeze':
			if int(es.ServerVar('sam_freeze_%s' % TOKENS[1])) == 0: freeze(TOKENS[1])
			else: unfreeze(TOKENS[1])
		elif TOKENS[0] == 'Noclip':
			if int(es.ServerVar('sam_noclip_%s' % TOKENS[1])) == 0: noclip(TOKENS[1])
			else: unnoclip(TOKENS[1])
		elif TOKENS[0] == 'Godmode':
			if int(es.ServerVar('sam_godmode_%s' % TOKENS[1])) == 0: god(TOKENS[1])
			else: ungod(TOKENS[1])
		elif TOKENS[0] == 'Jetpack':
			if int(es.ServerVar('sam_jetpack_%s' % TOKENS[1])) == 0: jetpack(TOKENS[1])
			else: unjetpack(TOKENS[1])
		elif TOKENS[0] == 'Blind':
			if int(es.ServerVar('sam_blind_%s' % TOKENS[1])) == 0: blind(TOKENS[1])
			else: unblind(TOKENS[1])
		elif TOKENS[0] == 'Rave':
			if int(es.ServerVar('sam_rave_%s' % TOKENS[1])) == 0: rave(TOKENS[1])
			else: unrave(TOKENS[1])
	if SEND: listPlayers(ID, TOKENS[0], None, TOKENS[1])

# =============================================================================== #
# === <<<> ONE TIME FUNCTIONS <>>> ============================================== #
# =============================================================================== #
def kick(ID, TARGET, REASON=False, MSG=True):
	if REASON: TARGET.kick(REASON)
	else: TARGET.kick(func.langPcontrol('KICKED_REASON'))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_KICKED', {'target':TARGET.name}), '#greenKICK')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slay(ID, TARGET, MSG=True):
	TARGET.kill()
	if MSG: func.tell('#all', func.langPcontrol('TARGET_SLAYED', {'target':TARGET.name}), '#greenSLAY')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def respawn(ID, TARGET, MSG=True):
	es.setplayerprop(TARGET, 'CCSPlayer.m_iPlayerState', 0)
	es.setplayerprop(TARGET, 'CCSPlayer.baseclass.m_lifeState', 512)
	es.server.insertcmd('es_xspawnplayer %s' % TARGET)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_RESPAWNED', {'target':TARGET.name}), '#greenRESPAWN')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def firework(ID, TARGET, MSG=True):
	if TARGET.isdead == 0:
		delay = 'sam_firework_%s' % TARGET
		func.sound(TARGET, 'weapons\physgun_off.wav', 1, 0.5)
		es.server.insertcmd('usermsg shake %s 100 2' % TARGET)
		gamethread.delayedname(0.1, delay, push, (TARGET, 20))
		gamethread.delayedname(0.2, delay, push, (TARGET, 45))
		gamethread.delayedname(0.3, delay, push, (TARGET, 80))
		gamethread.delayedname(0.4, delay, push, (TARGET, 125))
		gamethread.delayedname(0.5, delay, push, (TARGET, 180))
		gamethread.delayedname(0.6, delay, push, (TARGET, 245))
		gamethread.delayedname(0.7, delay, push, (TARGET, 320))
		gamethread.delayedname(0.8, delay, push, (TARGET, 405))
		gamethread.delayedname(0.9, delay, push, (TARGET, 500))
		gamethread.delayedname(0.9, delay, push, (TARGET, 520))
		gamethread.delayedname(1.4, delay, func.sound, (TARGET, 'weapons\c4\c4_beep1.wav', 1, 0.5))
		gamethread.delayedname(1.5, delay, func.sound, (TARGET, 'weapons\c4\c4_beep1.wav', 1, 0.5))
		gamethread.delayedname(1.7, delay, explosion, (TARGET))
		gamethread.delayedname(1.7, delay, func.sound, (TARGET, 'weapons/hegrenade/explode4.wav', 1, 0.5))
		if MSG: func.tell('#all', func.langPcontrol('TARGET_ISFIREWORK', {'target':TARGET.name}), '#greenFIREWORK')
	else: func.hudhint(ID, func.langPcontrol('TARGET_DEAD'),func.errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def health(ID, DATA, POPUP, MSG=True, SEND=True):
	DATA[0].setHealth(DATA[1])
	if MSG: func.tell('#all', func.langPcontrol('HEALTH_TOTARGET',{'target':DATA[0].name,'amount':DATA[1]}), '#greenHEALTH')
	if SEND:
		page(ID, False)
		listPlayers(ID, 'Health', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def cash(ID, DATA, POPUP, MSG=True, SEND=True):
	DATA[0].setCash(DATA[1])
	if MSG: func.tell('#all', func.langPcontrol('CASH_TOTARGET',{'target':DATA[0].name,'amount':DATA[1]}), '#greenCASH')
	if SEND:
		page(ID, False)
		listPlayers(ID, 'Cash', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slap(ID, DATA, POPUP=None, MSG=True, SEND=True):
	x = random.randint(-100, 100)
	y = random.randint(-100, 100)
	z = random.randint(100, 300)
	if not DATA[0].isdead:
		func.sound(DATA[0], 'player/damage%s.wav' % random.randint(1,3), 1, 0.2)
		es.setplayerprop(DATA[0], 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', es.createvectorstring(x,y,z))
		DATA[0].setHealth(DATA[0].getHealth()-DATA[1])
		string = str(DATA[0].getHealth())
		if int(DATA[0].getHealth()) == 0 or string.startswith('-'): DATA[0].kill()
		if MSG: func.tell('#all', func.langPcontrol('TARGET_SLAPED',{'target':DATA[0].name}), '#greenSLAP')
	else:
		if MSG: func.hudhint(ID, func.langPcontrol('TARGET_DEAD'), '#greenSLAP')
	if SEND: getDMG(ID, DATA[0], DATA[1])

# =============================================================================== #
# === <<<> TOGGLEABLE FUNCTIONS <>>> ============================================ #
# =============================================================================== #
def freeze(TARGET, MSG=True):
	var = es.ServerVar('sam_freeze_%s' % TARGET)
	var.set(1)
	TARGET.freeze(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_FREEZED',{'target':TARGET.name}),'#greenFREEZE')

# ------------------------------------------------------------------------------- #
def unfreeze(TARGET, MSG=True):
	var = es.ServerVar('sam_freeze_%s' % TARGET)
	var.set(0)
	if TARGET.teamid > 1: TARGET.freeze(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNFREEZED',{'target':TARGET.name}),'#greenFREEZE')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def noclip(TARGET, MSG=True):
	var = es.ServerVar('sam_noclip_%s' % TARGET)
	var.set(1)
	TARGET.noclip(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_NOCLIP',{'target':TARGET.name}),'#greenNOCLIP')

# ------------------------------------------------------------------------------- #
def unnoclip(TARGET, MSG=True):
	var = es.ServerVar('sam_noclip_%s' % TARGET)
	var.set(0)
	if TARGET.teamid > 1: TARGET.noclip(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNNOCLIP',{'target':TARGET.name}),'#greenNOCLIP')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def god(TARGET, MSG=True):
	var = es.ServerVar('sam_godmode_%s' % TARGET)
	var.set(1)
	TARGET.godmode(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_GOD',{'target':TARGET.name}),'#greenGODMODE')

# ------------------------------------------------------------------------------- #
def ungod(TARGET, MSG=True):
	var = es.ServerVar('sam_godmode_%s' % TARGET)
	var.set(0)
	if TARGET.teamid > 1: TARGET.godmode(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNGOD',{'target':TARGET.name}),'#greenGODMODE')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def jetpack(TARGET, MSG=True):
	var = es.ServerVar('sam_jetpack_%s' % TARGET)
	var.set(1)
	TARGET.jetpack(1)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_JET',{'target':TARGET.name}),'#greenJETPACK')

# ------------------------------------------------------------------------------- #
def unjetpack(TARGET, MSG=True):
	var = es.ServerVar('sam_jetpack_%s' % TARGET)
	var.set(0)
	if TARGET.teamid > 1: TARGET.jetpack(0)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNJET',{'target':TARGET.name}),'#greenJETPACK')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def blind(TARGET, MSG=True):
	var = es.ServerVar('sam_blind_%s' % TARGET)
	var.set(1)
	usermsg.fade(TARGET, 2, 1, 70, 0, 0, 0)
	gamethread.delayedname(.01, 'sam_blind_%s' % TARGET, blind, (TARGET,False))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_BLIND',{'target':TARGET.name}),'#greenBLIND')

# ------------------------------------------------------------------------------- #
def unblind(TARGET, MSG=True):
	var = es.ServerVar('sam_blind_%s' % TARGET)
	var.set(0)
	gamethread.cancelDelayed('sam_blind_%s' % TARGET)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNBLIND',{'target':TARGET.name}),'#greenBLIND')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rave(TARGET, MSG=True):
	var = es.ServerVar('sam_rave_%s' % TARGET)
	var.set(1)
	usermsg.shake(TARGET, random.randint(20, 30), 0.1)
	usermsg.fade(TARGET, 2, 1, 100, random.randint(0, 255), random.randint(0, 255), random.randint(0, 255), random.randint(100, 125))
	TARGET.setColor(random.randint(0, 255),random.randint(0, 255),random.randint(0, 255),random.randint(170, 255))
	gamethread.delayedname(.01, 'sam_rave_%s' % TARGET, rave, (TARGET,False))
	if MSG: func.tell('#all', func.langPcontrol('TARGET_RAVE',{'target':TARGET.name}),'#greenRAVE')

# ------------------------------------------------------------------------------- #
def unrave(TARGET, MSG=True):
	var = es.ServerVar('sam_rave_%s' % TARGET)
	var.set(0)
	gamethread.cancelDelayed('sam_rave_%s' % TARGET)
	TARGET.setColor(255,255,255,255)
	if MSG: func.tell('#all', func.langPcontrol('TARGET_UNRAVE',{'target':TARGET.name}),'#greenRAVE')

# =============================================================================== #
# === <<<> THIRD PARTY FUNCTIONS <>>> =========================================== #
# =============================================================================== #
def explosion(TARGET):
	if TARGET.isdead == 0:
		x,y,z = es.getplayerlocation(TARGET)
		es.server.queuecmd('es_xeffect sparks %s,%s,%s 9999 3 0,0,0' % (x, y, z))
		TARGET.kill()

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def push(TARGET, PUSH):
	if TARGET.isdead == 0: es.setplayerprop(TARGET, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '0,0,%s' % (PUSH))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getHealth(ID, TARGET):
	func.popupDelete('getHealth')
	popup = func.easymenu(popuplib.easymenu('getHealth', None, health),'pcontrol')
	popup.settitle(func.header(func.langPcontrol('HEALTH')))
	popup.addoption([TARGET,250], 250)
	popup.addoption([TARGET,1], 1)
	num = 5
	while num <= 100:
		popup.addoption([TARGET,num], num)
		num += 5
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getDMG(ID, TARGET,PAGE=False):
	func.popupDelete('getDMG')
	popup = func.easymenu(popuplib.easymenu('getDMG', None, slap),'pcontrol')
	popup.settitle(func.header(func.langPcontrol('SLAP')))
	popup.addoption([TARGET,0], func.langPcontrol('NO_DAMAGE'))
	popup.addoption([TARGET,1], 1)
	num  = 5
	nums = []
	while num <= 100:
		nums.append(num)
		num += 5
	for x in nums: popup.addoption([TARGET,x], x)
	if PAGE and PAGE in nums: popup.sendPage(ID, func.sendPage(nums.index(PAGE)+2))
	else: popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getCash(ID, TARGET):
	func.popupDelete('getHealth')
	popup = func.easymenu(popuplib.easymenu('getHealth', None, cash),'pcontrol')
	popup.settitle(func.header(func.langPcontrol('CASH')))
	popup.addoption([TARGET,0], 0)
	num = 800
	while num <= 16000:
		popup.addoption([TARGET,num], num)
		num += 800
	popup.send(ID)

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def kickCMD(ID, ARGS):
	if admins.can(ID,'Kick'):
		if ARGS:
			if len(ARGS) == 1:
				target = es.getuserid(ARGS[0])
				if es.exists('userid',target): kick(ID, playerlib.getPlayer(target))
				else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
			if len(ARGS) > 1:
				list = [es.getuserid(x) for x in ARGS]
				num  = 0
				for x in list:
					if es.exists('userid',x):
						kick(ID, playerlib.getPlayer(x),False,False)
						num+=1
				if num > 0: func.tell('#all', func.langPcontrol('KICK_MULTI_TARGETS',{'num':num}),'#greenKICK')
		else: listPlayers(ID, 'Kick', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slayCMD(ID, ARGS):
	if admins.can(ID,'Slay'):
		if ARGS:
			if len(ARGS) == 1:
				target = es.getuserid(ARGS[0])
				if es.exists('userid',target):
					target = playerlib.getPlayer(target)
					if not target.isdead: slay(ID, target)
					else: func.hudhint(func.langPcontrol('TARGET_DEAD'),'SLAY')
				else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
			if len(ARGS) > 1:
				list = [es.getuserid(x) for x in ARGS]
				num  = 0
				for x in list:
					if es.exists('userid',x):
						x = playerlib.getPlayer(x)
						if not x.isdead:
							slay(ID, x,False)
							num+=1
				if num > 0: func.tell('#all', func.langPcontrol('SLAY_MULTI_TARGETS',{'num':num}),'#greenSLAY')
		else: listPlayers(ID, 'Slay', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def fireworkCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			if len(ARGS) == 1:
				target = es.getuserid(ARGS[0])
				if es.exists('userid',target):
					target = playerlib.getPlayer(target)
					if not target.isdead: firework(ID, target)
					else: func.hudhint(func.langPcontrol('TARGET_DEAD'),'FIREWORK')
				else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
			if len(ARGS) > 1:
				list = [es.getuserid(x) for x in ARGS]
				num  = 0
				for x in list:
					if es.exists('userid',x):
						x = playerlib.getPlayer(x)
						if not x.isdead:
							firework(ID, x,False)
							num+=1
				if num > 0: func.tell('#all', func.langPcontrol('FIREWORK_MULTI_TARGETS',{'num':num}),'#greenFIREWORK')
		else: listPlayers(ID, 'Firework', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def respawnCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			if len(ARGS) == 1:
				target = es.getuserid(ARGS[0])
				if es.exists('userid',target):
					target = playerlib.getPlayer(target)
					if not target.isdead: respawn(ID, target)
					else: func.hudhint(func.langPcontrol('TARGET_DEAD'),'RESPAWN')
				else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
			if len(ARGS) > 1:
				list = [es.getuserid(x) for x in ARGS]
				num  = 0
				for x in list:
					if es.exists('userid',x):
						x = playerlib.getPlayer(x)
						if not x.isdead:
							respawn(ID, x,False)
							num+=1
				if num > 0: func.tell('#all', func.langPcontrol('RESPAWN_MULTI_TARGETS',{'num':num}),'#greenRESPAWN')
		else: listPlayers(ID, 'Firework', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def noclipCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				var    = es.ServerVar('sam_noclip_%s' % target)
				if int(var) == 0 and not target.isdead: noclip(target)
				elif int(var) == 1 and not target.isdead: unnoclip(target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Noclip', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def jetpackCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				var    = es.ServerVar('sam_jetpack_%s' % target)
				if int(var) == 0 and not target.isdead: jetpack(target)
				elif int(var) == 1 and not target.isdead: unjetpack(target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Jetpack', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def godmodeCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				var    = es.ServerVar('sam_godmode_%s' % target)
				if int(var) == 0 and not target.isdead: god(target)
				elif int(var) == 1 and not target.isdead: ungod(target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Godmode', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def blindCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				var    = es.ServerVar('sam_blind_%s' % target)
				if int(var) == 0 and not target.isdead: blind(target)
				elif int(var) == 1 and not target.isdead: unblind(target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Blind', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def raveCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				var    = es.ServerVar('sam_rave_%s' % target)
				if int(var) == 0 and not target.isdead: rave(target)
				elif int(var) == 1 and not target.isdead: unrave(target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Rave', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def freezeCMD(ID, ARGS):
	if admins.can(ID,'Fun Controls'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				var    = es.ServerVar('sam_freeze_%s' % target)
				if int(var) == 0 and not target.isdead: freeze(target)
				elif int(var) == 1 and not target.isdead: unfreeze(target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Freeze', None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def slapCMD(ID, ARGS):
	if admins.can(ID,'Slap'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				if len(ARGS) == 1 and not target.isdead: slap(ID, [target,0],None,True,False)
				elif len(ARGS) == 2:
					if str(ARGS[1]).isdigit() and not target.isdead: slap(ID, [target,int(ARGS[1])],None,True,False)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}),func.errortag)
		else: listPlayers(ID, 'Slap', None)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(EV):
	# SET PLAYER VARS
	for x in toggle: es.set('sam_%s_%s' % (x,int(EV['userid'])), 0)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(EV):
	# SET PLAYER VARS
	for x in es.getUseridList():
		for item in toggle: es.set('sam_%s_%s' % (item,x), 0)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_death(EV):
	target = playerlib.getPlayer(EV['userid'])
	unrave(target, False)
	unblind(target, False)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_spawn(EV):
	target = playerlib.getPlayer(EV['userid'])
	unrave(target, False)
	unblind(target, False)

# =============================================================================== #